## cameleon 1.9.21

=== Makefile ===
#################################################################################
#                Cameleon                                                       #
#                                                                               #
#    Copyright (C) 2004-2011 Institut National de Recherche en Informatique     #
#    et en Automatique. All rights reserved.                                    #
#                                                                               #
#    This program is free software; you can redistribute it and/or modify       #
#    it under the terms of the GNU Library General Public License as            #
#    published by the Free Software Foundation; either version 2 of the         #
#    License, or any later version.                                             #
#                                                                               #
#    This program is distributed in the hope that it will be useful,            #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of             #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              #
#    GNU Library General Public License for more details.                       #
#                                                                               #
#    You should have received a copy of the GNU Library General Public          #
#    License along with this program; if not, write to the Free Software        #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA                   #
#    02111-1307  USA                                                            #
#                                                                               #
#    Contact: Maxence.Guesdon@inria.fr                                          #
#                                                                               #
#################################################################################

include master.Makefile

SCRIPTS=

IMAGES=\
	images/bookmark.png \
	images/chamo.png \
	images/component.png \
	images/file_component.png \
	images/fun.png \
	images/run.png \
	images/tdl-group.png \
	images/tdl-item.png \
	images/tdl-item-done.png \
	images/tdl-item-high.png \
	images/tdl-item-low.png \
	images/tdl-item-suspended.png \
	images/topcameleon.xpm \
	images/type.png \
	images/value.png

# Compilation
#############

work: utils src

all: work srcdoc doc

src: dummy
	cd src && $(MAKE) all

utils: dummy
#	cd utils && $(MAKE) all

re : depend clean all

perl:
	$(ROOT)/utils/compile.sh

help:
	@echo "work:      utils src"
	@echo "all:       work srcdoc doc"
	@echo "src:       src/all"
	@echo "utils:     utils/all"
	@echo "re:        depend clean all"

# Documentation :
#################
srcdoc: dummy
	cd src && $(MAKE) doc

doc: dummy
	cd doc && $(MAKE) all

# myself

master.Makefile: master.Makefile.in config.status
	./config.status

config.status: configure master.Makefile.in \
	src/cameleon/cam_installation.ml.in \
	src/cameleon/cam_config.ml.in \
	src/custop/custop_installation.ml.in \
	src/report/rep_installation.ml.in \
	src/dbforge/dbf_installation.ml.in
	./config.status --recheck

configure: configure.in
	autoconf

# headers :
###########
HEADFILES= configure.in configure \
	master.Makefile.in Makefile \
	src/*/*.ml src/*/*.mli src/*/*.mll src/*/*.mly src/*/*.in \
	src/Makefile doc/Makefile utils/Makefile utils/checkocaml.ml
headers: dummy
	echo $(HEADFILES)
	headache -h header -c .headache_config `ls $(HEADFILES) | grep -v odot | grep -v cam-mktop2.in`

noheaders: dummy
	headache -r -c .headache_config `ls $(HEADFILES) | grep -v odot | grep -v cam-mktop.in`

# backup, clean and depend :
############################

distclean: clean
	cd src && $(MAKE) distclean
	cd doc && $(MAKE) distclean
	$(RM) config.cache config.log config.status master.Makefile
	$(RM) config_check.log ocaml_config.sh
	$(RM) images/topcameleon.xpm
#	cd utils && $(MAKE) distclean

clean: dummy
	$(RM) *~ \#*\#
	cd src && $(MAKE) clean
	cd doc && $(MAKE) clean
#	cd utils && $(MAKE) clean


depend: dummy
	cd src && $(MAKE) depend
alldepend: dummy
	cd src && $(MAKE) alldepend

dummy:

#################
# code count
#################
codecount:
	@echo `cat src/*/*.ml src/*/*.mli | wc -l` lines


#################
# installation
#################

install: dummy installimages
	cd src && $(MAKE) install
	$(MAKE) installspecsfiles
	$(MAKE) installdoc

installspecsfiles:
	$(MKDIR) $(LANGUAGESSPECSDIR)
	$(CP) utils/ocaml.lang $(LANGUAGESSPECSDIR)

installdoc:
	cd doc && $(MAKE) install

%.gif: %.png
	convert $< $@

%.xpm: %.png
	convert -scale 32x32 $< $@

installimages: dummy $(IMAGES)
	$(MKDIR) $(PIXMAPSDIR)
	$(CP) $(IMAGES) $(PIXMAPSDIR)

installscripts: dummy
#	$(MKDIR) $(DIR_UTILS)
#	$(CP) $(SCRIPTS) $(DIR_UTILS)

###########################
# additional dependencies
###########################

# DO NOT DELETE

=== doc/Makefile ===
#################################################################################
#                Cameleon                                                       #
#                                                                               #
#    Copyright (C) 2004-2011 Institut National de Recherche en Informatique     #
#    et en Automatique. All rights reserved.                                    #
#                                                                               #
#    This program is free software; you can redistribute it and/or modify       #
#    it under the terms of the GNU Library General Public License as            #
#    published by the Free Software Foundation; either version 2 of the         #
#    License, or any later version.                                             #
#                                                                               #
#    This program is distributed in the hope that it will be useful,            #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of             #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              #
#    GNU Library General Public License for more details.                       #
#                                                                               #
#    You should have received a copy of the GNU Library General Public          #
#    License along with this program; if not, write to the Free Software        #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA                   #
#    02111-1307  USA                                                            #
#                                                                               #
#    Contact: Maxence.Guesdon@inria.fr                                          #
#                                                                               #
#################################################################################

# $Id: Makefile 758 2011-01-13 07:53:27Z zoggy $

include ../master.Makefile

all: doc_stdlib doc_cameleon

STDLIB_DOC=stdlib.odoc
doc_stdlib:dummy
	$(OCAMLDOC) -I +threads \
	-dump $(STDLIB_DOC) \
	`ls $(OCAMLLIB)/*.mli | grep -v outcometree`

CAMELEON_DOC=cameleon.odoc
doc_cameleon:dummy
	cd $(ROOT)/src && $(MAKE) $(ROOT)/doc/$(CAMELEON_DOC)

install:
	@echo
	@echo Installing documentation...
	@echo
	@$(MKDIR) $(LIBDIR)
	@for i in $(STDLIB_DOC) $(CAMELEON_DOC); do \
	if test -f $$i; then \
                $(CP) $$i $(LIBDIR); echo $(LIBDIR)/`basename $$i` installed; \
        else \
                echo $$i NOT installed ; \
        fi; done
clean:
	$(RM) *.odoc
distclean: clean
dummy:

=== src/Makefile ===
#################################################################################
#                Cameleon                                                       #
#                                                                               #
#    Copyright (C) 2004-2011 Institut National de Recherche en Informatique     #
#    et en Automatique. All rights reserved.                                    #
#                                                                               #
#    This program is free software; you can redistribute it and/or modify       #
#    it under the terms of the GNU Library General Public License as            #
#    published by the Free Software Foundation; either version 2 of the         #
#    License, or any later version.                                             #
#                                                                               #
#    This program is distributed in the hope that it will be useful,            #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of             #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              #
#    GNU Library General Public License for more details.                       #
#                                                                               #
#    You should have received a copy of the GNU Library General Public          #
#    License along with this program; if not, write to the Free Software        #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA                   #
#    02111-1307  USA                                                            #
#                                                                               #
#    Contact: Maxence.Guesdon@inria.fr                                          #
#                                                                               #
#################################################################################

include ../master.Makefile

SYSTEM_INCLUDES= \
	-I +threads \
	-I +ocamldoc \
	-I ocaml/parsing \
	-I ocaml/typing \
	$(OCAML_DRIVER_INCLUDES) \
	-I ocaml/utils \
	$(PCRE_INCLUDES) \
	$(LABLGTK2_INCLUDES) \
	$(LABLGTKEXTRAS_INCLUDES) \
	$(XMLLIGHT_INCLUDES)

MY_INCLUDES= \
	-I odot \
	-I utils \
	-I odiff \
	-I tdl \
	-I rss \
	-I tmpl-engine \
	-I sqml \
	-I report \
	-I dbforge \
	-I ocamlcvs \
	-I editor \
	-I cameleon \
	-I camtop \
	-I custop \
	-I multiclip \
	-I plugins \
	-I snippets

INCLUDES= \
	$(SYSTEM_INCLUDES) \
	$(MY_INCLUDES)

MKCHAMO_INCLUDES= \
	-I +threads \
	-I +ocamldoc \
	$(OCAML_DRIVER_INCLUDES) \
	-I $(LIBDIR) \
	$(PCRE_INCLUDES) \
	$(LABLGTK2_INCLUDES) \
	$(LABLGTKEXTRAS_INCLUDES) \
	$(XMLLIGHT_INCLUDES)

COMPFLAGS=$(INCLUDES)
LINKFLAGS=$(INCLUDES)
LINKFLAGS_BYTE=$(INCLUDES)

#OCAMLPP=-pp "$(OCAMLBIN)/camlp4o "

TOOLS=$(REPORT) $(REPORT_GUI) $(TMPL_ENGINE) \
	$(DBFORGE) $(DBFORGE_GUI) \
	$(OCAMLCVS) $(TDL) $(TDL_EXPORT) $(TDL_HTML) $(TDL_SVN) \
	$(RSS) $(RSS_EXPORT)\
	$(EDITOR) $(CAMELEON) $(CAM_CONFIG) $(DOCBROWSER)
TOOLS_BYTE=$(REPORT_BYTE) $(REPORT_GUI_BYTE) \
	$(TMPL_ENGINE_BYTE) \
	$(DBFORGE_BYTE) $(DBFORGE_GUI_BYTE) \
	$(OCAMLCVS_BYTE) \
	$(TDL_BYTE) $(TDL_EXPORT_BYTE) $(TDL_HTML_BYTE) $(TDL_SVN_BYTE) \
	$(RSS_BYTE) $(RSS_EXPORT_BYTE) \
	$(EDITOR_BYTE) $(CAMELEON_BYTE) $(CAM_CONFIG_BYTE) $(DOCBROWSER_BYTE) $(CAMTOP)

UTILS=\
	utils/ffind.cmx \
	utils/dtypes.cmx
UTILS_BYTE=\
	utils/ffind.cmo \
	utils/dtypes.cmo

PLUGINS=plugins/test.cmo plugins/dep_view.cma

# Compilation
#############

# Cameleon
# files shared with editor
CAMELEON_SHARED_CMOFILES=\
	cameleon/cam_messages.cmo \
	cameleon/cam_config.cmo \
	cameleon/cam_dbg.cmo \
	cameleon/cam_misc.cmo \
	cameleon/cam_constant.cmo \
	cameleon/cam_rc.cmo \
	cameleon/cam_com_history.cmo \
	cameleon/cam_hooks.cmo \
	cameleon/cam_commands.cmo \
	cameleon/cam_log.cmo \
	cameleon/cam_args.cmo

CAMELEON_COMMON_CMOFILES=\
	$(EDITOR_COMMON_CMOFILES) \
	cameleon/cam_chamo.cmo \
	cameleon/cam_gui_base.cmo \
	cameleon/cam_gui.cmo \
	cameleon/cam_keymaps.cmo \
	cameleon/cam_view.cmo \
	cameleon/cam_dir_view.cmo \
	cameleon/cam_doc.cmo \
	cameleon/cam_doc_gui.cmo

PRE_CAMELEON_CMOFILES=$(CAMELEON_COMMON_CMOFILES) \
	cameleon/cam_minibuffer.cmo \
	cameleon/cam_files.cmo \
	cameleon/cam_cvs_view.cmo \
	cameleon/cam_files_view.cmo \
	cameleon/cam_modules_view.cmo \
	cameleon/cam_multiview.cmo \
	cameleon/cam_bbar.cmo \
	cameleon/cam_new_project.cmo \
	cameleon/cam_menus.cmo \
	cameleon/cam_server.cmo \
	cameleon/cam_plug.cmo \
	cameleon/cam_rss.cmo

CAMELEON_CMOFILES=$(PRE_CAMELEON_CMOFILES) \
	editor/ed_eval.cmo \
	cameleon/cam_plugins.cmo \
	cameleon/cam_main.cmo

CAMELEON_CMXFILES=$(PRE_CAMELEON_CMOFILES:.cmo=.cmx) \
	cameleon/cam_main.cmx

CAMELEON_CMIFILES= $(CAMELEON_CMOFILES:.cmo=.cmi)

CAM_CONFIG_CMOFILES=\
	cameleon/cam_installation.cmo \
	cameleon/cam_config.cmo \
	cameleon/cam_config_main.cmo

CAM_CONFIG_CMXFILES=$(CAM_CONFIG_CMOFILES:.cmo=.cmx)
CAM_CONFIG_CMIFILES=$(CAM_CONFIG_CMOFILES:.cmo=.cmi)

DOCBROWSER_CMOFILES=$(CAMELEON_COMMON_CMOFILES) \
	cameleon/cam_docbrowser.cmo

DOCBROWSER_CMXFILES= $(DOCBROWSER_CMOFILES:.cmo=.cmx)
DOCBROWSER_CMIFILES= $(DOCBROWSER_CMOFILES:.cmo=.cmi)

# Editor

EDITOR_COMMON_CMOFILES=\
	utils/dtypes.cmo \
	$(CAMELEON_SHARED_CMOFILES) \
	editor/ed_config.cmo \
	editor/ed_messages.cmo \
	editor/ed_prefs.cmo \
	editor/ed_gui_base.cmo \
	editor/ed_keymaps.cmo \
	editor/ed_gui_rc.cmo \
	editor/ed_bookmarks.cmo \
	editor/ed_fstack.cmo \
	editor/ed_sourceview_rc.cmo \
	editor/ed_minibuffer_rc.cmo \
	editor/ed_minibuffer.cmo \
	editor/ed_charsets.cmo \
	editor/ed_core_rc.cmo \
	editor/ed_outputs.cmo \
	editor/ed_misc.cmo \
	editor/ed_view_rc.cmo \
	editor/ed_view.cmo \
	editor/ed_multiclip_rc.cmo \
	editor/ed_multiclip.cmo \
	editor/ed_odoc_rc.cmo \
	editor/ed_odoc.cmo \
	editor/ed_tdl_rc.cmo \
	editor/ed_tdl.cmo \
	editor/ed_sourceview.cmo \
	editor/ed_sourceview_expand.cmo \
	editor/ed_ocamloutput.cmo \
	editor/ed_ocaml_lexer.cmo \
	editor/ed_mode_ocaml_rc.cmo \
	editor/ed_ocamlbuild.cmo \
	editor/ed_mode_ocaml.cmo \
	editor/ed_mode_makefile_rc.cmo \
	editor/ed_mode_makefile.cmo \
	editor/ed_mode_changelog_rc.cmo \
	editor/ed_mode_changelog.cmo \
	editor/ed_gui.cmo \
	editor/ed_layout.cmo

EDITOR_COMMON_CMIFILES=$(EDITOR_COMMON_CMOFILES:.cmo=.cmi)
EDITOR_COMMON_CMXFILES=$(EDITOR_COMMON_CMOFILES:.cmo=.cmx)

EDITOR_CMOFILES=$(EDITOR_COMMON_CMOFILES) \
	editor/ed_eval.cmo \
	editor/ed_main.cmo
EDITOR_CMXFILES=$(EDITOR_COMMON_CMOFILES:.cmo=.cmx) editor/ed_main.cmx
EDITOR_CMIFILES=$(EDITOR_COMMON_CMOFILES:.cmo=.cmi) editor/ed_main.cmi

LIBEDITOR=editor/chamo.cmxa
LIBEDITOR_A=$(LIBEDITOR:.cmxa=.a)

EDITOR_LIBS=$(LIBEDITOR) $(LIBEDITOR_A)

EDITOR_LINK_LIBS=str.cmxa unix.cmxa threads.cmxa xml-light.cmxa \
	lablgtk.cmxa lablglade.cmxa gtkThread.cmx gtkInit.cmx \
	lablgtksourceview2.cmxa \
	config_file.cmx lablgtkextras.cmxa configwin.cmxa \
	multiclip/multiclip.cmx multiclip/multiclip_gui.cmx \
	cameleon/cam_installation.cmx \
	tdl.cmxa tdl_gui.cmxa \
	odoc_info.cmxa \
	pcre.cmxa
EDITOR_LINK_LIBS_BYTE=str.cma unix.cma threads.cma xml-light.cma \
	toplevellib.cma \
	lablgtk.cma lablglade.cma gtkThread.cmo gtkInit.cmo \
	lablgtksourceview2.cma \
	config_file.cmo lablgtkextras.cma configwin.cma \
	multiclip/multiclip.cmo multiclip/multiclip_gui.cmo \
	cameleon/cam_installation.cmo \
	tdl.cma tdl_gui.cma \
	odoc_info.cma \
	pcre.cma
MKCHAMO_LINK_LIBS=str.cmxa unix.cmxa threads.cmxa xml-light.cmxa \
	lablgtk.cmxa lablglade.cmxa gtkThread.cmx gtkInit.cmx \
	lablgtksourceview2.cmxa \
	config_file.cmx lablgtkextras.cmxa configwin.cmxa \
	multiclip.cmx multiclip_gui.cmx \
	cam_installation.cmx \
	tdl.cmxa tdl_gui.cmxa \
	odoc_info.cmxa \
	pcre.cmxa

MKCHAMO_SCRIPT=editor/make_my_chamo

# Odot

LIBODOT=odot/odot.cmxa
LIBODOT_BYTE=$(LIBODOT:.cmxa=.cma)
LIBODOT_CMI=$(LIBODOT:.cmxa=.cmi)
LIBODOT_A=$(LIBODOT:.cmxa=.a)
LIBODOT_VIEW=odot/odot_view.cmx
LIBODOT_VIEW_BYTE=$(LIBODOT_VIEW:.cmx=.cmo)
LIBODOT_VIEW_CMI=$(LIBODOT_VIEW:.cmx=.cmi)
LIBODOT_VIEW_O=$(LIBODOT_VIEW:.cmx=.o)
ODOT_LIBS=$(LIBODOT) $(LIBODOT_BYTE) $(LIBODOT_CMI) $(LIBODOT_A) \
	$(LIBODOT_VIEW) $(LIBODOT_VIEW_BYTE) $(LIBODOT_VIEW_CMI) $(LIBODOT_VIEW_O)

# Tdl

TDL_COMMON_CMOFILES=\
	tdl/tdl_messages.cmo \
	tdl/tdl_date.cmo \
	tdl/tdl_types.cmo \
	tdl/tdl_io.cmo \
	tdl/tdl_filter.cmo \
	tdl/tdl_filter_parser.cmo \
	tdl/tdl_filter_lexer.cmo \
	tdl/tdl.cmo

LIBTDL_CMOFILES=$(TDL_COMMON_CMOFILES)
LIBTDL_CMIFILES=$(LIBTDL_CMOFILES:.cmo=.cmi)
LIBTDL_CMXFILES=$(LIBTDL_CMOFILES:.cmo=.cmx)

TDL_EXPORT_CMOFILES=tdl/tdl_export.cmo
TDL_EXPORT_CMIFILES=$(TDL_EXPORT_CMOFILES:.cmo=.cmi)
TDL_EXPORT_CMXFILES=$(TDL_EXPORT_CMOFILES:.cmo=.cmx)

TDL_SVN_CMOFILES=tdl/tdl_svn.cmo
TDL_SVN_CMIFILES=$(TDL_SVN_CMOFILES:.cmo=.cmi)
TDL_SVN_CMXFILES=$(TDL_SVN_CMOFILES:.cmo=.cmx)

TDL_HTML_CMOFILES=tdl/tdl2html.cmo
TDL_HTML_CMIFILES=$(TDL_HTML_CMOFILES:.cmo=.cmi)
TDL_HTML_CMXFILES=$(TDL_HTML_CMOFILES:.cmo=.cmx)

LIBTDL=tdl/tdl.cmxa
LIBTDL_BYTE=$(LIBTDL:.cmxa=.cma)
LIBTDL_CMI=$(LIBTDL:.cmxa=.cmi)
LIBTDL_A=$(LIBTDL:.cmxa=.a)

LIBTDL_GUI_CMOFILES=\
	tdl/tdl_gui_rc.cmo \
	tdl/tdl_gui_base.cmo \
	tdl/tdl_gui.cmo
LIBTDL_GUI_CMIFILES=$(LIBTDL_GUI_CMOFILES:.cmo=.cmi)
LIBTDL_GUI_CMXFILES=$(LIBTDL_GUI_CMOFILES:.cmo=.cmx)

LIBTDL_GUI=tdl/tdl_gui.cmxa
LIBTDL_GUI_BYTE=$(LIBTDL_GUI:.cmxa=.cma)
LIBTDL_GUI_CMI=$(LIBTDL_GUI:.cmxa=.cmi)
LIBTDL_GUI_A=$(LIBTDL_GUI:.cmxa=.a)

TDL_CMOFILES=tdl/tdl_main.cmo
TDL_CMIFILES=$(TDL_CMOFILES:.cmo=.cmi)
TDL_CMXFILES=$(TDL_CMOFILES:.cmo=.cmx)

ODOC_TDL_CMOFILES=$(TDL_COMMON_CMOFILES) tdl/odoc_tdl.cmo
ODOC_TDL=tdl/odoc_tdl.cma
ODOC_TDL_CMI=$(ODOC_TDL:.cma=.cmi)

TDL_LIBS=$(LIBTDL) $(LIBTDL_BYTE) $(LIBTDL_CMI) $(LIBTDL_A) \
	$(LIBTDL_GUI) $(LIBTDL_GUI_BYTE) $(LIBTDL_GUI_CMI) $(LIBTDL_GUI_A)

# RSS

RSS_COMMON_CMOFILES=\
	rss/rss_messages.cmo \
	rss/rss_date.cmo \
	rss/rss_types.cmo \
	rss/rss_io.cmo \
	rss/rss.cmo

LIBRSS_CMOFILES=$(RSS_COMMON_CMOFILES)
LIBRSS_CMIFILES=$(LIBRSS_CMOFILES:.cmo=.cmi)
LIBRSS_CMXFILES=$(LIBRSS_CMOFILES:.cmo=.cmx)

LIBRSS=rss/rss.cmxa
LIBRSS_BYTE=$(LIBRSS:.cmxa=.cma)
LIBRSS_CMI=$(LIBRSS:.cmxa=.cmi)
LIBRSS_A=$(LIBRSS:.cmxa=.a)

LIBRSS_GUI_CMOFILES=\
	rss/rss_gui_base.cmo \
	rss/rss_gui.cmo
LIBRSS_GUI_CMIFILES=$(LIBRSS_GUI_CMOFILES:.cmo=.cmi)
LIBRSS_GUI_CMXFILES=$(LIBRSS_GUI_CMOFILES:.cmo=.cmx)

LIBRSS_GUI=rss/rss_gui.cmxa
LIBRSS_GUI_BYTE=$(LIBRSS_GUI:.cmxa=.cma)
LIBRSS_GUI_CMI=$(LIBRSS_GUI:.cmxa=.cmi)
LIBRSS_GUI_A=$(LIBRSS_GUI:.cmxa=.a)

RSS_CMOFILES=rss/rss_gui_main.cmo
RSS_CMIFILES=$(RSS_CMOFILES:.cmo=.cmi)
RSS_CMXFILES=$(RSS_CMOFILES:.cmo=.cmx)

RSS_EXPORT_CMOFILES=rss/rss_export.cmo
RSS_EXPORT_CMIFILES=$(RSS_EXPORT_CMOFILES:.cmo=.cmi)
RSS_EXPORT_CMXFILES=$(RSS_EXPORT_CMOFILES:.cmo=.cmx)

RSS_LIBS=$(LIBRSS) $(LIBRSS_BYTE) $(LIBRSS_CMI) $(LIBRSS_A) \
	$(LIBRSS_GUI) $(LIBRSS_GUI_BYTE) $(LIBRSS_GUI_CMI) $(LIBRSS_GUI_A)


# Tmpl-engine

TMPL_COMMON_CMOFILES=\
	tmpl-engine/template.cmo \
	tmpl-engine/tmplParser.cmo \
	tmpl-engine/tmplLexer.cmo \
	tmpl-engine/tmplIO.cmo


TMPL_CMOFILES=$(TMPL_COMMON_CMOFILES) \
	tmpl-engine/main.cmo
TMPL_CMXFILES= $(TMPL_CMOFILES:.cmo=.cmx)
TMPL_CMIFILES= $(TMPL_CMOFILES:.cmo=.cmi)

TMPL_LIB_CMOFILES=$(TMPL_COMMON_CMOFILES)
TMPL_LIB_CMXFILES= $(TMPL_LIB_CMOFILES:.cmo=.cmx)
TMPL_LIB_CMIFILES= $(TMPL_LIB_CMOFILES:.cmo=.cmx)

LIBTMPL=tmpl-engine/tmpl-engine.cmxa
LIBTMPL_BYTE=$(LIBTMPL:.cmxa=.cma)
LIBTMPL_CMI=$(LIBTMPL:.cmxa=.cmi)
LIBTMPL_A=$(LIBTMPL:.cmxa=.a)

TMPL_LIBS=$(LIBTMPL) $(LIBTMPL_BYTE) $(LIBTMPL_A) #$(LIBTMPL_CMI)

# SQML

SQML_CMOFILES=\
	sqml/sqml_sqlstx.cmo \
	sqml/sqml_helper_lp.cmo \
	sqml/sqml_parser.cmo \
	sqml/sqml_lexer.cmo \
	sqml/sqml_pp.cmo \
	sqml/sqml.cmo

SQML_CMXFILES= $(SQML_CMOFILES:.cmo=.cmx)
SQML_CMIFILES= $(SQML_CMOFILES:.cmo=.cmi)

LIBSQML=sqml/sqml.cmxa
LIBSQML_BYTE=$(LIBSQML:.cmxa=.cma)
LIBSQML_CMI=$(LIBSQML:.cmxa=.cmi)
LIBSQML_A=$(LIBSQML:.cmxa=.a)

SQML_LIBS=$(LIBSQML) $(LIBSQML_BYTE) $(LIBSQML_A) $(LIBSQML_CMI)

# Report

REPORT_COMMON_CMOFILES=\
	report/rep_installation.cmo \
	report/rep_messages.cmo \

=== utils/Makefile ===
#################################################################################
#                Cameleon                                                       #
#                                                                               #
#    Copyright (C) 2004-2011 Institut National de Recherche en Informatique     #
#    et en Automatique. All rights reserved.                                    #
#                                                                               #
#    This program is free software; you can redistribute it and/or modify       #
#    it under the terms of the GNU Library General Public License as            #
#    published by the Free Software Foundation; either version 2 of the         #
#    License, or any later version.                                             #
#                                                                               #
#    This program is distributed in the hope that it will be useful,            #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of             #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              #
#    GNU Library General Public License for more details.                       #
#                                                                               #
#    You should have received a copy of the GNU Library General Public          #
#    License along with this program; if not, write to the Free Software        #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA                   #
#    02111-1307  USA                                                            #
#                                                                               #
#    Contact: Maxence.Guesdon@inria.fr                                          #
#                                                                               #
#################################################################################

# $Id: Makefile 758 2011-01-13 07:53:27Z zoggy $

include ../master.Makefile

all: config_check.cmo

clean:
	rm -f *~ \#*\#
	rm -f *.cm*

distclean: clean

=== src/dbforge/example/Makefile ===
# $Id
# Example of use of DBForge

include ../../../master.Makefile

INCLUDES= -I `ocamlfind query mysql` -I ../dbf_lib
COMPFLAGS=$(INCLUDES)
SRCFILES=dbf_mysql.ml \
	base.ml \
	example.ml

all: example.byte

example.byte: base.cmi $(SRCFILES)
	$(OCAMLC) -o $@ $(INCLUDES) \
	str.cma unix.cma mysql.cma dbf_sql_driver.cmo dbf_sql_misc.cmo $(SRCFILES)

dbf_mysql.ml: ../dbf_lib/dbf_mysql.ml
	$(CP) $< $@
base.ml: base.xml
	$(ROOT)/src/dbforge2.x -o base.ml base.xml
base.mli: base.ml
	$(OCAMLC) -i $(INCLUDES) $< > $@

clean:
	$(RM) *.cm* *~ base.ml base.mli dbf_mysql.ml example.byte

=== src/dbforge/ocamlsql/test/Makefile ===
##########################################################################
#                   Cameleon                                             #
#                                                                        #
#      Copyright (C) 2002 Institut National de Recherche en Informatique et   #
#      en Automatique. All rights reserved.                              #
#                                                                        #
#      This program is free software; you can redistribute it and/or modify  #
#      it under the terms of the GNU General Public License as published by  #
#      the Free Software Foundation; either version 2 of the License, or  #
#      any later version.                                                #
#                                                                        #
#      This program is distributed in the hope that it will be useful,   #
#      but WITHOUT ANY WARRANTY; without even the implied warranty of    #
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     #
#      GNU General Public License for more details.                      #
#                                                                        #
#      You should have received a copy of the GNU General Public License  #
#      along with this program; if not, write to the Free Software       #
#      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA          #
#      02111-1307  USA                                                   #
#                                                                        #
#      Contact: Maxence.Guesdon@inria.fr                                #
##########################################################################

include ../../../../master.Makefile

CMOFILES =  parse.cmo
CMIFILES =  $(CMOFILES:.cmo=.cmi)
CMXFILES =  $(CMOFILES:.cmo=.cmx)

COMPFLAGS=-I ..

PROG=parse
PROG_OPT=parse_opt

####

all: $(PROG)
opt: $(PROG_OPT)


$(PROG): $(CMOFILES)
	$(OCAMLC) -custom -o $@ str.cma ../ocamlsql.cma $(CMOFILES)  \
	-ccopt -L$(LIBDIR) -cclib -ldl -cclib -lunix -cclib -lstr $(LINKFLAGS)

$(PROG_OPT): $(CMXFILES)
	$(OCAMLOPT) -o $@ str.cmxa $(OCAMLSQL_OPT) $(CMXFILES)  \
	-ccopt -L$(LIBDIR) -cclib -ldl -cclib -lunix -cclib -lstr $(LINKFLAGS)

clean_all: clean
	$(RM) $(CMOFILES) $(CMXFILES) $(CMIFILES) *.o
	$(RM) $(PROG) $(PROG_OPT)

clean:
	$(RM) *~ #*# *-

=== debian/changelog ===
cameleon (1.9.21-1build1) precise; urgency=low

  * Rebuild for OCaml 3.12.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 19 Nov 2011 16:56:44 +0000

cameleon (1.9.21-1) unstable; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sun, 11 Sep 2011 17:06:41 +0200

=== debian/control ===
Source: cameleon
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>,
 Sylvain Le Gall <gildor@debian.org>,
 Samuel Mimram <smimram@debian.org>
Build-Depends:
 patchutils (>= 0.2.25),
 cdbs (>= 0.4.27),
 ocaml-nox (>= 3.12),
 po4a, docbook-xml (>= 4.4), docbook-xsl, libxml2-utils, xsltproc,
 debhelper (>= 7),
 dh-ocaml (>= 0.9.1~),
 camlp4,
 ocaml-findlib (>= 1.2.5),
 liblablgtk2-ocaml-dev (>= 2.14),
 libxml-light-ocaml-dev (>= 2.2-12~),
 liblablgtksourceview2-ocaml-dev,
 liblablgtk-extras-ocaml-dev,
 libconfig-file-ocaml-dev,
 libpcre-ocaml-dev (>= 6.0.1-2~),
 imagemagick,
 docbook-ebnf
Standards-Version: 3.9.2
Homepage: http://home.gna.org/cameleon/
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/cameleon.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/cameleon.git

Package: cameleon
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests: cameleon-doc
Description: integrated development environment for OCaml
 Cameleon is a set of tools and libraries put together to create an
 integrated development environment for the OCaml programming language.
 .
 Its main features are :
  - graphical user interface,
  - configuration management based on CVS,
  - easy access to and browsing of documentation,
  - various editors, according to customizable file types,
  - use of plug-ins to define new features,
  - highly customizable interface (menus, toolbar, keyboard shortcuts).
 .
 Tools shipped are :
  - Chamo, a source code editor based on the GtkSourceView widget with some
    emacs-like functionality,
  - DBforge, a tool to describe database schemas and generate OCaml code to
    access these databases,
  - OCamlCVS, a graphical front end for the CVS configuration management
    utility,
  - Report, a tool aims to make generation of XML documents from OCaml
    applications easier,

Package: cameleon-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: documentation for Cameleon
 It contains documentation build with Cameleon:
  - Cameleon reference manual
  - Cameleon user manual,
 .
 Documentation can be in HTML, Postscript or odoc formats.

Package: libcameleon-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests: ocaml-findlib, cameleon-doc
Provides: ${ocaml:Provides}
Description: libraries from Cameleon
 It contains the libraries built with Cameleon:
  - Config_file, create configuration files,
  - Configwin, build configuration or input windows in LablGTK,
  - Odiff, print and parse differences between files or strings, in the diff
    utility format,
  - Odot, parse and print Graphviz dot files,
  - Okey, add handlers to key press events in LablGTK,
  - Tdl, represent, store and read TODO lists in XML files,

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for cameleon package
# Copyright (C) 2006 Sylvain Le Gall <gildor@debian.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
# MA 02110-1301, USA.

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/ocaml.mk
include /usr/share/cdbs/1/class/autotools.mk
include $(CURDIR)/debian/mk/docbook-manpage.mk

PACKAGE := cameleon
DESTDIR := $(CURDIR)/debian/$(PACKAGE)

PACKAGE_DEV := libcameleon-ocaml-dev
DESTDIR_DEV := $(CURDIR)/debian/$(PACKAGE_DEV)

PACKAGE_DOC := cameleon-doc
DESTDIR_DOC := $(CURDIR)/debian/$(PACKAGE_DOC)

OCAMLDOC_PLUGINSDIR := $(DESTDIR)/$(shell ocamldoc -customdir)

DEB_MAKE_CLEAN_TARGET    := distclean

DEB_MAKE_BUILD_TARGET    := depend all doc

DEB_MAKE_INSTALL_TARGET  := install                                      \
                            DESTDIR='$(DESTDIR)'                         \
			    OCAMLDOC_PLUGINSDIR='$(OCAMLDOC_PLUGINSDIR)'

DEB_CONFIGURE_EXTRA_FLAGS = --prefix=/usr --datadir=/usr/share/cameleon \
                            --mandir=/usr/share/man                     \
                            --libdir=$(OCAML_STDLIB_DIR)/cameleon

DEB_STRIP_EXCLUDE := .byte

PO4A_SOURCES := $(CURDIR)/debian/xml-man/po4a/po4a.cfg

DOCBOOK_MANPAGE_SOURCES := $(CURDIR)/debian/xml-man/en/cam-config2.byte.xml  \
                           $(CURDIR)/debian/xml-man/en/cameleon2.byte.xml    \
                           $(CURDIR)/debian/xml-man/en/cam-mktop2.xml        \
                           $(CURDIR)/debian/xml-man/en/dbforge2.byte.xml     \
                           $(CURDIR)/debian/xml-man/en/dbforge2.gui.byte.xml \
                           $(CURDIR)/debian/xml-man/en/docbrowser2.byte.xml  \
                           $(CURDIR)/debian/xml-man/en/ocamlcvs2.byte.xml    \
                           $(CURDIR)/debian/xml-man/en/report2.byte.xml      \
                           $(CURDIR)/debian/xml-man/en/report2.gui.byte.xml  \
                           $(CURDIR)/debian/xml-man/en/tmpl_engine.byte.xml  \
                           $(CURDIR)/debian/xml-man/en/chamo.byte.xml        \
                           $(CURDIR)/debian/xml-man/en/ocamltdl2.byte.xml    \
                           $(CURDIR)/debian/xml-man/en/tdl.byte.xml	     \
                           $(CURDIR)/debian/xml-man/en/tdl_export.byte.xml   \
                           $(CURDIR)/debian/xml-man/en/make_my_chamo.xml     \
                           $(CURDIR)/debian/xml-man/en/tdl2html.byte.xml     \
                           $(CURDIR)/debian/xml-man/en/ocamlrss2.byte.xml    \
                           $(CURDIR)/debian/xml-man/en/rss_export.byte.xml   \
                           $(CURDIR)/debian/xml-man/en/tdl_svn.byte.xml

DOCBOOK_MANPAGE_EXTRA_SOURCES := $(CURDIR)/debian/xml-man/en/license.xml      \
                                 $(CURDIR)/debian/xml-man/en/refentryinfo.xml

OCAML_OCAMLDOC_PACKAGES_DOCBASE := cameleon-doc
OCAML_DHOCAML_FLAGS := -Xodoc_tdl.cma

# These cannot be erased by debian/clean mechanisms becore they are touched
# by upstream `make clean'
clean::
	-$(RM) '$(CURDIR)/src/custop/custop_installation.ml'

install/cameleon install/cameleon-doc install/libcameleon-ocaml-dev:: cameleon-install-extra

cameleon-install-extra: common-install-indep common-install-arch
	VERSION=$(DEB_NOEPOCH_VERSION); \
	VERSION=$${VERSION%%-*}; \
	sed -i "s/@VERSION@/$$VERSION/g" '$(CURDIR)/debian/META.cameleon'
	# Remove unused binaries
	$(RM) $(DESTDIR)/usr/bin/*.x
	# Move documentation (cameleon-doc)
	mv $(DESTDIR)/$(OCAML_STDLIB_DIR)/cameleon/*.odoc \
	  '$(DESTDIR_DOC)/$(OCAML_STDLIB_DIR)/cameleon'
	# Install library (libcameleon-ocaml-dev)
	mv '$(DESTDIR)/$(OCAML_STDLIB_DIR)/cameleon' \
	  '$(DESTDIR_DEV)/$(OCAML_STDLIB_DIR)'

.PHONY: cameleon-install-extra

MAKE_MY_CHAMO := $(DESTDIR)/usr/bin/make_my_chamo
install/cameleon::
	mv '$(MAKE_MY_CHAMO)' '$(MAKE_MY_CHAMO).tmp'
	(echo '#!/bin/sh'; cat '$(MAKE_MY_CHAMO).tmp') > '$(MAKE_MY_CHAMO)'
	$(RM) '$(MAKE_MY_CHAMO).tmp'
